#include "Info.h"

template<typename T>
struct Compare
{
	using is_transparent = void;

	bool operator() (const T& a, const T& b) const {
		return a->name < b->name;
	}

	bool operator() (const T& a, const string &b) const {
		return a->name < b;
	}

	bool operator() (const string &a, const T& b) const {
		return a < b->name;
	}
};


template<typename T,
	typename = typename std::enable_if<std::is_base_of<VarInfo, T>::value>::type,
	typename TPtr = shared_ptr<T>>
class InfoList : public set<TPtr, Compare<TPtr>> {
public:
	InfoList<T> *parent;
	InfoList(InfoList<T> *parent = nullptr) : parent(parent) {};
	TPtr operator[](string name) const {
		TPtr ret = local(name);
		return ret ? ret : parent ? (*parent)[name] : nullptr;
	}

	TPtr local(string name) const {
		const auto p = this->find(name);
		return p != this->end() ? *p : nullptr;
	}

	void add(TPtr obj) {
		this->emplace(obj);
	}

	InfoList<T>& operator<<(TPtr obj) {
		add(obj);
		return *this;
	}
};
